CheckLayer = cc.Layer.extend({
	_num:null,
	_stage:null,
	_cb:null,

	background:null,
	layer_back:null,
	menu_retry:null,
	menu_next:null,
	menu_ok:null,
	menu:null,
	lab_desc:null,

	back_listener:null,

	ctor:function (num, stage, cb){
		this._super();
		this._num = num;
		this._stage = stage;
		this._cb = cb;
		this.createComponents();
		this.showAnimation();
	},

	createComponents:function(){
		var size = cc.winSize;
		this.layer_back = new cc.LayerColor(cc.color("#000000"), size.width, size.height);
		this.layer_back.opacity = 150;
		this.layer_back.x = 0;
		this.layer_back.y = 0;
		this.addChild(this.layer_back, 0);

		this.background = new cc.Sprite(resPaht("chose", "", "finish"));
		this.background._setAnchorX(0.5);
		this.background._setAnchorY(0.5);
		this.background.scale = 0;
		this.background.x = size.width / 2;
		this.background.y = size.height / 2;
		this.addChild(this.background, 1);

		var self = this;

		var array_menu_item = [];
		this.menu_retry = new cc.MenuItemImage(
				resPaht("chose", "", "oncemore"),
				resPaht("chose", "", "oncemore"),
				function(){
					if (self.back_listener) {
						self.back_listener.release();
						self.back_listener = null;
					}
					if (self._cb) {
						self._cb("retry");
					}
				},this);

		this.menu_retry.setPosition(-35, -150);
		this.menu_retry.scale = 0;
		this.menu_retry._setAnchorX(1);
		this.menu_retry._setAnchorY(1);
		array_menu_item[0] = this.menu_retry;


		this.menu_next = new cc.MenuItemImage(
				resPaht("chose", "", "next"),
				resPaht("chose", "", "next"),
				function(){
					if (self.back_listener) {
						self.back_listener.release();
						self.back_listener = null;
					}
					
					if (self._cb) {
						self._cb("next");
					}
				},this);

		this.menu_next.setPosition(35, -150);
		this.menu_next.scale = 0;
		this.menu_next._setAnchorX(0);
		this.menu_next._setAnchorY(1);
		array_menu_item[1] = this.menu_next;

		this.menu = new cc.Menu(array_menu_item);
		this.addChild(this.menu, 10);
		
		var rect = this.background.getTextureRect();
		this.lab_desc = new cc.LabelTTF("", "Arial", 40, cc.size(500,200), cc.TEXT_ALIGNMENT_CENTER, cc.VERTICAL_TEXT_ALIGNMENT_CENTER);
		this.lab_desc.setPosition(cc.p(cc.winSize.width / 2, cc.winSize.height / 2));
		this.lab_desc.setFontFillColor(cc.color(0, 0, 0, 255));
		this.lab_desc.scale = 0;
		this.addChild(this.lab_desc, 11);
		var point = Config_Choose.percent[this._num];
		var percent = randomFrom(point.x, point.y);
		this.lab_desc.setString("小朋友，你共答对" + this._num + "道题目\n超过了" + percent + "%的同伴！");

		var self = this;
		var layer_listener = cc.EventListener.create({
			event: cc.EventListener.TOUCH_ONE_BY_ONE,
			swallowTouches: true,
			onTouchBegan: function (touch, event) {
				cc.log("touch begin");

				return true;
			},
			onTouchMoved: function (touch, event) {

			},
			onTouchEnded: function (touch, event) {
			}
		});
		this.back_listener = layer_listener.clone();
		this.back_listener.retain();

		cc.eventManager.addListener(this.back_listener, this.layer_back);
	},
	showAnimation:function(){
		customPlayEffect(aePath("success", false, true));
		this.background.runAction(cc.sequence(cc.scaleTo(0.2, 1.1, 1.1), cc.scaleTo(0.1, 1, 1)));
		this.lab_desc.runAction(cc.sequence(cc.scaleTo(0.2, 1.1, 1.1), cc.scaleTo(0.1, 1, 1)));
		this.menu_retry.runAction(cc.sequence(cc.scaleTo(0.2, 1.1, 1.1), cc.scaleTo(0.1, 1, 1)));
		this.menu_next.runAction(cc.sequence(
				cc.scaleTo(0.2, 1.1, 1.1), 
				cc.scaleTo(0.1, 1, 1)));
	}
});

