
var ChoseLayer = cc.Layer.extend({
	arry_src:null,
	target:null,
	cur_index : null,
	cur_stage:null,
	arry_listener:null,
	arry_sprites:null,
	target_sprite:null,
	clock:null,
	progress_bar:null,
	sprite_stage:null,
	check_layer:null,
	right_num:null,
    ctor:function () {
        //////////////////////////////
        // 1. super init first
        this._super();
    
		this.cur_stage = 0;
        this.arry_src = new Array();
        this.arry_sprites = new Array();
        this.target = new ChoseItem();
        this.cur_index = 0;
        this.right_num = 0;
        this.genTarAndSrc();
        this.createLayer();
        this.createSpriteListener();
        this.pauseListener();
        this.reshuffleLayer();
        
        this.addBackKeyListener();

        return true;
    },
    createLayer:function(){
    	cc.log();
    	var background = new cc.Sprite(resPaht("select", null, "background"));
    	background.setAnchorPoint(cc.p(0, 0));
    	background.scaleX = winWidth() / 1136;
    	this.addChild(background, 0);
    	
    	this.progress_bar = new ProgressBar(resPaht("chose", null, "progress_back"), resPaht("chose", null, "progress"));
    	this.progress_bar.setPosition(Config_Choose.pos_progress);
    	this.addChild(this.progress_bar, 2);
    	this.progress_bar.setVisible(false);
    	
    	this.target_sprite = new TargetSprite(this.target);
    	this.target_sprite.setPosition(Config_Choose.pos.target);
    	this.target_sprite.setVisible(false);
    	this.target_sprite.setScale(Config_Choose.tar_scale);
    	this.addChild(this.target_sprite, 4);
    	
    	this.clock = new cc.Sprite(resPaht("chose", "null", "clock"));
    	this.clock.setPosition(Config_Choose.pos_clock);
    	this.clock.setVisible(false);
    	this.addChild(this.clock, 5);
    	
    	this.sprite_stage = new StageSprite();
    	this.sprite_stage.setPosition(Config_Choose.pos.score);
    	this.addChild(this.sprite_stage, 6);
    	this.sprite_stage.setVisible(false);
    	this.sprite_stage.setIndex(this.right_num, 12);
    	
    	for(var n_index = 0; n_index < this.arry_src.length; ++n_index){
    		this.arry_sprites[n_index] = new SrcSprite(this.arry_src[n_index]);
    		this.arry_sprites[n_index].setPosition(Config_Choose.pos.src[n_index]);
    		this.arry_sprites[n_index].setVisible(false);
    		this.addChild(this.arry_sprites[n_index], 7 + n_index);
    	}
    	
    	var self = this;
    	addBackMenu(this.menu, this, function() {
    		ddStopAllAudios();
    		self.cleanScene();
    		cc.director.popScene();
		});
    },
    showCheckLayer:function(){
    	if (this.check_layer) {
			this.check_layer.removeFromParent(true);
			this.check_layer = null;
		}
    	var self = this;
    	this.check_layer = new CheckLayer(this.right_num, this.cur_stage, function(action) {
			switch (action) {
			case "next":
			{
				self.cur_stage++;
				self.cur_index = 0;
				
				break;
			}
			case "retry":
			{
				self.cur_index = 0;
				break;
			}
			default:
				break;
			}
			self.check_layer.removeFromParent(true);
			self.check_layer = null;
			self.right_num = 0;
			self.sprite_stage.setIndex(self.right_num, 12);
			self.genTarAndSrc();
			self.reshuffleLayer();
		});
    	
    	this.addChild(this.check_layer, 300);
    },
    reshuffleLayer:function(){
    	cc.log("reshuffle layer!!!");
    	this.unscheduleAllCallbacks();
    	this.target_sprite.setVisible(true);
    	this.target_sprite.setInfo(this.target);
    	this.sprite_stage.setVisible(true);
    	this.progress_bar.restore();
    	this.progress_bar.setVisible(true);
    	this.clock.setVisible(true);
    	for(var n_index = 0; n_index < this.arry_src.length; ++n_index){
    		this.arry_sprites[n_index].setRight(false, true);
    		this.arry_sprites[n_index].setVisible(true);
    		this.arry_sprites[n_index].setInfo(this.arry_src[n_index]);
    	}
    	customPlayEffect(audioPath("", this.target.getType(), this.target.getPic(), ""), false, true);
    	this.resumeListener();
    	var self = this;
    	this.scheduleOnce(function() {
			self.progress_bar.start();
		}, 0.5);
    	this.checkTimeout();
    },
    checkTimeout:function(){
    	var self = this;
    	this.scheduleOnce(function() {
    		self.pauseListener();
			self.showWrongStatus();
    	}, Config_Choose.time);
    },
    createSpriteListener:function(){
    	this.arry_listener = [null, null, null, null];
    	
    	var self = this;
    	var sprite_listener = cc.EventListener.create({
    		event: cc.EventListener.TOUCH_ONE_BY_ONE,
    		swallowTouches: true,
    		onTouchBegan: function (touch, event) {
    			self.sprite_select = null;
    			var target = event.getCurrentTarget();
    			var locationInNode = target.convertToNodeSpace(touch.getLocation());

    			var s = target.getContentSize();
    			var rect = cc.rect(0, 0, s.width, s.height);

    			if (cc.rectContainsPoint(rect, locationInNode)) {
    				self.sprite_select = target;
    				if (!target.isEnable()) {
						return false;
					}
    				return true;
    			}else {
    				self.sprite_select = null;
    			}
    			return false;
    		},
    		onTouchMoved: function (touch, event) {
    			
    		},
    		onTouchEnded: function (touch, event) {
    			self.checkSelect();
    		}
    	});

    	this.arry_listener[0] = sprite_listener.clone();
    	this.arry_listener[0].retain();
    	this.arry_listener[1] = sprite_listener.clone();
    	this.arry_listener[1].retain();
    	this.arry_listener[2] = sprite_listener.clone();
    	this.arry_listener[2].retain();
    	this.arry_listener[3] = sprite_listener.clone();
    	this.arry_listener[3].retain();
    	
    	cc.eventManager.addListener(this.arry_listener[0], this.arry_sprites[0]);
    	cc.eventManager.addListener(this.arry_listener[1], this.arry_sprites[1]);
    	cc.eventManager.addListener(this.arry_listener[2], this.arry_sprites[2]);
    	cc.eventManager.addListener(this.arry_listener[3], this.arry_sprites[3]);
    },
    pauseListener:function(){
    	for (var n_index = 0; n_index < this.arry_sprites.length; n_index++) {
			var src_spr = this.arry_sprites[n_index];
			src_spr.setEnable(false);
			src_spr.setRight(false, true);
		}
    },
    resumeListener:function(){
    	for (var n_index = 0; n_index < this.arry_sprites.length; n_index++) {
    		var src_spr = this.arry_sprites[n_index];
    		src_spr.setEnable(true);
    	}
    },
    checkSelect:function(){
    	if (this.sprite_select) {
    		this.unscheduleAllCallbacks();
    		this.pauseListener();
    		this.progress_bar.stop();
			if (this.sprite_select.getType() == this.target_sprite.getType() && (this.sprite_select.getName() == this.target_sprite.getName())) {
				cc.log("check success!!!");
				this.showRightStatus();
				this.right_num++;
				this.sprite_stage.setIndex(this.right_num, 12);
			} else {
				cc.log("check fail!!!");
				this.showWrongStatus();
			}
//			
//			
//			this.cur_index++;
//			this.reshufGame();
		} else {
			cc.log("check fail!!!");
		}
    	
    	this.sprite_select = null;
    },
    showRightStatus:function(){
    	customPlayEffect(aePath("right"), false, true);
    	if (this.sprite_select) {
			this.sprite_select.setRight(true, true);
		}
    	
    	this.renewLayer();
    },
    showWrongStatus:function(){
    	customPlayEffect(aePath("fail"), false, true);
		for (var n_index = 0; n_index < this.arry_sprites.length; n_index++) {
			if (this.target_sprite.getName() == this.arry_sprites[n_index].getName()) {
				this.arry_sprites[n_index].setRight(true, true);	
			} else {
				this.arry_sprites[n_index].setRight(true, false);
			}
				
		}
		
		this.renewLayer();
    },
    renewLayer:function(){
    	
    	var self = this;
    	this.scheduleOnce(function() {
    		self.cur_index++;
    		if (self.cur_index >= 12) {
    			self.showCheckLayer();
    		}else {
    			cc.log("renew layer!" + self.cur_stage);
    			if (self.cur_stage > 4) {
					self.genSeniorTarAndSrc();
				} else {
					self.genTarAndSrc();
				}
    			self.reshuffleLayer();
    		}
    	}, 3);
    },
    showEntryAni:function(){
    	this.arry_cate[this.cur_index].runAction(cc.sequence(
    		cc.scaleTo(0.2, 0.9),
    		cc.scaleTo(0.3, 1.1),
    		cc.scaleTo(0.2, 0.9),
    		cc.delayTime(1),
    		cc.callFunc(function(){
    			this.cur_index = (this.cur_index + 1) % 4;
    			this.showEntryAni();
    		}.bind(this))
    	));
    },
    cleanScene:function(){
    	cc.log("clean scene click!");
    	for (var n_index = 0; n_index < this.arry_listener.length; n_index++) {
    		cc.eventManager.removeListener(this.arry_listener[n_index]);
    		releaseObj(this.arry_listener[n_index]);
    	}
    },
    addBackKeyListener:function(){
    	var self = this;
    	cc.eventManager.addListener({
    		event: cc.EventListener.KEYBOARD,
    		onKeyReleased: function(keyCode, event) {
    			if (keyCode == cc.KEY.back) {
    				ddStopAllAudios();
    				self.cleanScene();
    				cc.director.popScene();
    			}
    		}}, this);
    },
    genTarAndSrc:function(){
    	switch (this.cur_stage) {
		case 0:
		{
			this.target.setInfo(Config_Game.fruit[this.cur_index]);
			
			this.genSrcArray(this.target, Config_Game.fruit, 4);
			break;
		}
		case 1:
		{
			this.target.setInfo(Config_Game.vegetable[this.cur_index]);

			this.genSrcArray(this.target, Config_Game.vegetable, 4);
			break;
		}
		case 2:
		{
			this.target.setInfo(Config_Game.car[this.cur_index]);

			this.genSrcArray(this.target, Config_Game.car, 4);
			break;
		}
		case 3:
		{
			this.target.setInfo(Config_Game.animal[this.cur_index]);

			this.genSrcArray(this.target, Config_Game.animal, 4);
			break;
		}
		case 4:
        {
        	this.target.setInfo(Config_Game.yesheng[this.cur_index]);

        	this.genSrcArray(this.target, Config_Game.yesheng, 4);
        	break;
        }
		default:
		{
			this.genSeniorTarAndSrc();
			break;
		}
		}
    },
    genSrcArray:function(target, arry_src, length){
    	var arry_temp = new Array();
    	for (var n_index = 0; n_index < arry_src.length; n_index++) {
			var cur_item = new ChoseItem();
			cur_item.setInfo(arry_src[n_index]);
			if ((cur_item.getPic() == target.getPic()) && (cur_item.getType() == target.getType())) {
				
			}else {
				arry_temp.push(cur_item);
			}
		}
    	cc.log("array temp size " + arry_temp.length);
    	arry_temp = shuffle(arry_temp);
    	this.arry_src.length = 0;
    	arry_temp = arry_temp.slice(0, length - 1);
    	arry_temp[length - 1] = target;
    	this.arry_src = shuffle(arry_temp)
    	cc.log("array src size " + this.arry_src.length);
    },
    genSeniorTarAndSrc:function(){
    	var src_fruit = new ChoseItem();
    	src_fruit.setInfo(Config_Game.fruit[Math.floor(Math.random()*100) % 12]);
    	
    	var src_veg = new ChoseItem();
    	src_veg.setInfo(Config_Game.vegetable[Math.floor(Math.random()*100) % 12]);
    	
    	var src_animal = new ChoseItem();
    	src_animal.setInfo(Config_Game.animal[Math.floor(Math.random()*100) % 12]);
    	
    	var src_car = new ChoseItem();
    	src_car.setInfo(Config_Game.car[Math.floor(Math.random()*100) % 12]);

    	var src_yesheng = new ChoseItem();
    	src_yesheng.setInfo(Config_Game.yesheng[Math.floor(Math.random()*100) % 12]);

    	var arry_temp = new Array(src_fruit, src_veg, src_animal, src_car, src_yesheng);
    	this.arry_src = shuffle(arry_temp).slice(0, 4);
    	this.target = this.arry_src[Math.floor(Math.random()*100) % 4];
    }
});

var ChoseScene = cc.Scene.extend({
    ctor:function () {
        this._super();
        var layer = new ChoseLayer();
        this.addChild(layer);
    }
});

