var ad_gap_v = 20;
var ad_height = 90;

AdViewLayer = cc.Layer.extend({
    layer_back:null,
    background:null,
    head_icon:null,
    arry_ad_sprite:null,
    arry_ad_listener:null,
    ad_items:null,
    size:null,
    ad_index:null,
    ctor:function (ad_items, winSize){
        this._super();

        ad_gap_v = 20;
        ad_height = 90;
        this.ad_index = 0;

        this.ad_items = ad_items;

        this.size = winSize;

        this.createComponents();

        this.loadAdImages();

        this.showAnimation();

        this.addListeners();
    },

    createComponents:function(){

        this.head_icon = new cc.Sprite(resPath("listad", "head"));

        this.head_icon._setAnchorX(0.5);
        this.head_icon._setAnchorY(0.5);
        this.head_icon.scale = 0.8;
        this.head_icon.x = this.size.width / 2;
        this.head_icon.y = 88.5 * this.head_icon.scale;

        this.addChild(this.head_icon);

        var self = this;
        var ad_listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                cc.log("touch begin");

                var target = event.getCurrentTarget();
                var locationInNode = target.convertToNodeSpace(touch.getLocation());

                var s = target.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);

                if (cc.rectContainsPoint(rect, locationInNode)) {

                    self.checkSelectIndex(target);

                    return false;
                }
                return false;

                return false;
            },
            onTouchMoved: function (touch, event) {

            },
            onTouchEnded: function (touch, event) {
            }
        });

        if (this.ad_items) {
            this.arry_ad_listener = [];
            this.arry_ad_sprite = [];

            var ad_length = this.ad_items.length> 4 ? 4 : this.ad_items.length;

            for (var ad_index = 0; ad_index < ad_length; ad_index++) {
                var n_odd = ad_index % 2;
                if (0 == n_odd){
                    n_odd = -1;
                }
                this.arry_ad_sprite[ad_index] = new cc.Sprite("res/listad/default");
                this.arry_ad_sprite[ad_index]._setAnchorX(0.5);
                this.arry_ad_sprite[ad_index]._setAnchorY(0.5);
                this.arry_ad_sprite[ad_index].setPosition(cc.p(this.size.width / 2, 220 + ad_index * 120));
                this.arry_ad_sprite[ad_index].scale = 0.5;
                this.arry_ad_sprite[ad_index].rotation = n_odd * 15;
                this.arry_ad_sprite[ad_index].opacity = 255;
                cc.log(this.ad_items[ad_index].getPic());

                this.addChild(this.arry_ad_sprite[ad_index], 10 + ad_index);

                this.arry_ad_listener[ad_index] = ad_listener.clone();
                this.arry_ad_listener[ad_index].retain();
            }
        }
    },
    addListeners:function(){
        if(this.arry_ad_sprite){
            for (var n_ad_index = 0; n_ad_index < this.arry_ad_sprite.length; n_ad_index++) {
                cc.eventManager.addListener(this.arry_ad_listener[n_ad_index], this.arry_ad_sprite[n_ad_index]);
            }
        }
    },
    showAnimation:function(){
        var scale = this.arry_ad_sprite[this.ad_index].scale;
        this.arry_ad_sprite[this.ad_index].runAction(
            cc.sequence(
                cc.delayTime(2),
                cc.scaleTo(0.2, 1.2 * scale),
                cc.scaleTo(0.2, 0.8 * scale),
                cc.scaleTo(0.1, 1.1 * scale),
                cc.scaleTo(0.1, 0.9 * scale),
                cc.scaleTo(0.1, 1 * scale),
                cc.callFunc(function () {
                    this.ad_index = (this.ad_index + 1) % this.ad_items.length;
                    this.showAnimation();
                }.bind(this))
            )
        );

    },
    checkSelectIndex:function(target){
        console.log("select index is " + target);
        for (var n_ad = 0; n_ad < this.arry_ad_sprite.length; n_ad++) {
            if (target == this.arry_ad_sprite[n_ad]) {
                cc.log("ad is clicked : " + this.ad_items[n_ad].getName());
                openMarket(this.ad_items[n_ad]);
                break;
            }
        }
    },
    loadAdImages:function(){
        for (var n_ad = 0; n_ad < this.ad_items.length; n_ad++) {
            setWebImage(this.ad_items[n_ad].getPic(), this.arry_ad_sprite[n_ad]);
        }
    }
});
