
QuitAdViewLayer = cc.Layer.extend({
    isRoot:null,
    _cb:null,
    _adItem:null,

    background:null,
    layer_back:null,
    menu_quit:null,
    menu_continue:null,
    menu_close:null,
    menu:null,

    app_sprite:null,

    back_listener:null,
    app_listener:null,

    ctor:function (cb, ad_item){
        this._super();
        this._cb = cb;
        this._adItem = ad_item;
        this.createComponents();
        if (this._adItem){
            setWebImage(ad_item.getQuitPic(), this.app_sprite);
        }
    },

    createComponents:function(){
        var size = cc.winSize;
        this.layer_back = new cc.LayerColor(cc.color("#000000"), size.width, size.height);
        this.layer_back.opacity = 150;
        this.layer_back.x = 0;
        this.layer_back.y = 0;
        this.addChild(this.layer_back, 0);

        this.background = new cc.Sprite("res/quitad/quit_back");
        this.background._setAnchorX(0.5);
        this.background._setAnchorY(0.5);
        this.background.scale = 1;
        this.background.x = size.width / 2;
        this.background.y = size.height / 2;
        this.addChild(this.background, 1);

        var sprite_title = new cc.Sprite("res/quitad/head");
        sprite_title.x = size.width / 2;
        sprite_title.y = size.height /2 + 175 + 22;
        this.addChild(sprite_title, 2);

        var self = this;

        var array_menu_item = [];
        this.menu_quit = new cc.MenuItemImage(
            "res/quitad/quit",
            "res/quitad/quit",
            function(){
                self.cleanRes();
                console.log("quit click!!!");
                if (self._cb) {
                    self._cb("quit");
                }
            },this);

        this.menu_quit.setPosition(-22, -210);
        this.menu_quit.scale = 1;
        this.menu_quit._setAnchorX(1);
        this.menu_quit._setAnchorY(1);
        array_menu_item[0] = this.menu_quit;


        this.menu_continue = new cc.MenuItemImage(
            "res/quitad/continue",
            "res/quitad/continue",
            function(){
                self.cleanRes();
                console.log("continue click!!!");
                if (self._cb) {
                    self._cb("continue");
                }
            },this);

        this.menu_continue.setPosition(22, -210);
        this.menu_continue.scale = 1;
        this.menu_continue._setAnchorX(0);
        this.menu_continue._setAnchorY(1);
        array_menu_item[1] = this.menu_continue;

        this.menu_close = new cc.MenuItemImage(
            "res/quitad/close",
            "res/quitad/close",
            function(){
                self.cleanRes();
                console.log("close click!!!");
                if (self._cb) {
                    self._cb("continue");
                }
            },this);

        this.menu_close.setPosition(230, 228);
        this.menu_close.scale = 1.2;
        this.menu_close._setAnchorX(0);
        this.menu_close._setAnchorY(1);
        array_menu_item[2] = this.menu_close;

        this.menu = new cc.Menu(array_menu_item);
        this.addChild(this.menu, 10);

        this.app_sprite = new cc.Sprite("res/quitad/q_default");
        this.app_sprite.x = size.width / 2;
        this.app_sprite.y = size.height / 2 - 28;
        this.addChild(this.app_sprite, 2);

        var layer_listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                cc.log("touch begin");

                var locationInNode = self.app_sprite.convertToNodeSpace(touch.getLocation());
                var s = self.app_sprite.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);
                if(cc.rectContainsPoint(rect, locationInNode)){
                    console.log("app item clicked!!!!");
                    if (self._adItem){
                        openMarket(self._adItem);
                    }
                    return true;
                }

                return true;
            },
            onTouchMoved: function (touch, event) {

            },
            onTouchEnded: function (touch, event) {
            }
        });


        this.back_listener = layer_listener.clone();
        this.back_listener.retain();

        cc.eventManager.addListener(this.back_listener, this.background);
    },
    cleanRes:function(){
        if(this.back_listener){
            this.back_listener.release();
            this.back_listener = null;
        }
    }
});
