function playAudio(audio_path, is_music, loop){
    var audioid = '';

    if(cc.sys.os === cc.sys.OS_IOS){
        if(is_music){
            cc.audioEngine.playMusic(audio_path,loop);
        }else{
            audioid = cc.audioEngine.playEffect(audio_path,loop);
        }
    }else{
        jsb.AudioEngine.play2d(audio_path,loop);
    }

    return audioid;
}
function stopAllAudios() {
    if(cc.sys.os === cc.sys.OS_IOS){
        cc.audioEngine.stopAllEffects();
        cc.audioEngine.stopMusic(true);
    }else{
        cc.audioEngine.stopMusic(true);
        jsb.AudioEngine.stopAll();
    }
}

function getImagePath(str_url){
    if(cc.sys.os == cc.sys.OS_ANDROID){
    		return jsb.reflection.callStaticMethod("com/duoduo/child/story/thirdparty/cocos/NativeInteraction", "getImgLocalPath", "(Ljava/lang/String;)Ljava/lang/String;",str_url);
    }else if(cc.sys.os == cc.sys.OS_IOS){
   		return null;
    }
}

function setLocalImage(str_url, sprite, width, height){
    var sprite_src = new cc.Sprite(str_url);
    sprite.updateWithSprite(sprite_src, cc.rect(0, 0, sprite_src.width, sprite_src.height), false, cc.p(0, 0), cc.size(width, height), cc.rect(0, 0, 0, 0));
}

function setWebImage(str_url, sprite){
    var local_path = getImagePath(str_url);
    if(!local_path || !local_path.length){
        cc.loader.loadImg(str_url, null, function(err, img){
        		if(err){
        			cc.log("error orrur!!!");
        		}else {
        			cc.log("load success!!!");
        			sprite.setTexture(img);
        		}
        	});
    }else {
        sprite.setTexture(local_path);
    }
}

function isPad(){
    if(cc.sys.os == cc.sys.OS_ANDROID){
        return jsb.reflection.callStaticMethod("com/duoduo/child/story/thirdparty/cocos/NativeInteraction", "isPad", "()Z");
    }else if(cc.sys.os == cc.sys.OS_IOS){
    	return false;
    }
}

function winWidth(){
    if(cc.sys.os == cc.sys.OS_IOS){
        return 1136;
    }

    var strSize = jsb.reflection.callStaticMethod("com/duoduo/child/story/thirdparty/cocos/NativeInteraction", "getScreenSize", "()Ljava/lang/String;");
    if(strSize && strSize.length){
        var parse_result = JSON.parse(strSize);
        var width = parseInt(parse_result.width);
        var height = parseInt(parse_result.height);

        if(isPad()){
            return width / height * 852;
        }else{
            return width / height * 640;
        }
    }

    return 1136;
}

function gapX(){
    if(cc.sys.os == cc.sys.OS_IOS){
       return 0;
    }
    if(isPad())
        return 0;

    if((winWidth() - 1136) > 30)
        return 30;

    return 0;
}

function getChannel(){
   if(cc.sys.os == cc.sys.OS_ANDROID){
       return jsb.reflection.callStaticMethod("com/duoduo/child/story/thirdparty/cocos/NativeInteraction", "getChannel", "()Ljava/lang/String;");
   }else{
       return "AppStore";
   }
}

function getPackage(){
    if(cc.sys.os == cc.sys.OS_ANDROID){
           return jsb.reflection.callStaticMethod("com/duoduo/child/story/thirdparty/cocos/NativeInteraction", "getPackage", "()Ljava/lang/String;");
       }else{
           return "com.qinqinxiong.learn.music";
       }
}

function verCode(){
    if(cc.sys.os == cc.sys.OS_ANDROID){
        return jsb.reflection.callStaticMethod("com/duoduo/child/story/thirdparty/cocos/NativeInteraction", "verCode", "()Ljava/lang/String;");
    }else{
        return "1001";
    }
}

function getConfig(key){
    if(cc.sys.os == cc.sys.OS_ANDROID){
        return jsb.reflection.callStaticMethod("com/duoduo/child/story/thirdparty/cocos/NativeInteraction",
        "readFile", "(Ljava/lang/String;)Ljava/lang/String;", key);
    }
}

function setConfig(key, value){
    if(cc.sys.os == cc.sys.OS_ANDROID){
        jsb.reflection.callStaticMethod("com/duoduo/child/story/thirdparty/cocos/NativeInteraction",
                "saveToFile", "(Ljava/lang/String;Ljava/lang/String;)V", key, value);
    }
}

function openMarket(ad_item){
	if(cc.sys.os == cc.sys.OS_ANDROID){
		jsb.reflection.callStaticMethod("com/duoduo/child/story/thirdparty/cocos/NativeInteraction", "OpenMarket", "(Ljava/lang/String;)V",ad_item.getArUrl());
	}else if(cc.sys.os == cc.sys.OS_IOS){
		jsb.reflection.callStaticMethod("NativeInteraction", "OpenMarket:", ad_item.getIOSUrl());
	}
}

function showPrivacy(){
    if(cc.sys.os == cc.sys.OS_ANDROID){
        jsb.reflection.callStaticMethod("com/duoduo/child/story/thirdparty/cocos/NativeInteraction",
                "showPrivacy", "()V");
    }
}

function showFeed(){
    if(cc.sys.os == cc.sys.OS_ANDROID){
        jsb.reflection.callStaticMethod("com/duoduo/child/story/thirdparty/cocos/NativeInteraction",
                    "startFeedbackActivity", "()V");
    }
}


