
var HomeLayer = cc.Layer.extend({
	title:null,
	menu_game:null,
	menu_video:null,
	menu:null,
	cur_index:null,
	_adview:null,
    layer_quit:null,
	
    ctor:function () {
        //////////////////////////////
        // 1. super init first
        this._super();
        this.cur_index = 0;
        this.createLayer();
        this.showBeginAni();
        this.addBackKeyListener();

        this.getAdList(function () {
            if (AD_ENABLE && ARRY_AD_HOME.length != 0) {
                this._adview = new AdViewLayer(ARRY_AD_HOME, cc.size(180 + 2 * gapX()));
                this.addChild(this._adview, 230);
            }
        }.bind(this));
        return true;
    },
    createLayer:function(){
    	var background = new cc.Sprite(resPaht("home", null, "background"));
    	background.setAnchorPoint(cc.p(0, 0));
    	background.scaleX = winWidth() / 1136;
    	this.addChild(background, 0);
    	
    	this.title = new cc.Sprite(resPaht("home", null, "title"));
    	this.title.setPosition(Config_Home.title.pos_begin);
    	this.addChild(this.title, 1);

    	var btn_privacy = new ccui.Button("res/home/privacy","res/home/privacy");
        btn_privacy.setPosition(cc.p(cc.winSize.width - 120, cc.winSize.height - 70));
        btn_privacy.addTouchEventListener(this.btnTouchEvent, this);
        this.addChild(btn_privacy, 3);

        var btn_feed = new ccui.Button("res/home/feed", "res/home/feed");
        btn_feed.setPosition(cc.p(cc.winSize.width - 350, cc.winSize.height - 70));
        btn_feed.addTouchEventListener(this.feedTouchEvent, this);
        this.addChild(btn_feed, 4);
    	
    	var array_menu_item = [];

    	this.menu_game = new cc.MenuItemImage(
    		resPaht("home", null, "play"),
    		resPaht("home", null, "play"),
    		function () {
    			playAudio(audioTipsPath(), false, false);
    			cc.director.pushScene(new cc.TransitionFade(0.3, new SelectScene()));
    	}, this);
    	this.menu_game.attr({
    		x: Config_Home.btn_play.pos.x,
    		y: Config_Home.btn_play.pos.y,
    		anchorX: 0.5,
    		anchorY: 0.5,
    		scale:0
    	});
    	array_menu_item[0] = this.menu_game;
    	
    	this.menu_video = new cc.MenuItemImage(
    			resPaht("home", null, "video"),
    			resPaht("home", null, "video"),
    			function () {
    				playAudio(audioTipsPath(), false, false);
    				cc.director.pushScene(new cc.TransitionFade(0.3, new ChoseScene()));
    			}, this);
    	this.menu_video.attr({
    		x: Config_Home.btn_video.pos.x,
    		y: Config_Home.btn_video.pos.y,
    		anchorX: 0.5,
    		anchorY: 0.5,
    		scale:0
    	});
    	array_menu_item[1] = this.menu_video;
    	
    	this.menu = new cc.Menu(array_menu_item);
    	this.menu.x = 0;
    	this.menu.y = 0;
    	this.addChild(this.menu, 4);
    	this.menu.setEnabled(false);
    },
    showBeginAni:function(){
    	this.title.runAction(cc.sequence(cc.moveTo(1, Config_Home.title.pos_end).easing(cc.easeOut(3)), 
    			cc.delayTime(0.1),
    			cc.callFunc(function() {
					this.showBtnAni();
				}.bind(this))));
    },
    showBtnAni:function(){
    	this.menu_game.runAction(cc.scaleTo(0.2, 1));
    	this.menu_video.runAction(cc.sequence(cc.scaleTo(0.2, 1), cc.callFunc(function() {
			this.btnAniRepeat();
			this.menu.setEnabled(true);
		}.bind(this))));
    },
    btnAniRepeat:function(){
    	if (0 == this.cur_index % 2) {
    		this.menu_game.runAction(cc.sequence(
    				cc.scaleTo(Config_Home.scale_invterval, Config_Home.btn_play.scale_begin),
    				cc.scaleBy(2 * Config_Home.scale_invterval, Config_Home.btn_play.scale_end),
    				cc.scaleTo(Config_Home.scale_invterval, 1),
    				cc.delayTime(Config_Home.scale_time_gap),
    				cc.callFunc(function() {
						this.cur_index++;
						this.btnAniRepeat();
					}.bind(this))
    		));
		} else {
			this.menu_video.runAction(cc.sequence(
					cc.scaleTo(Config_Home.scale_invterval, Config_Home.btn_video.scale_begin),
					cc.scaleBy(Config_Home.scale_invterval * 2, Config_Home.btn_video.scale_end),
					cc.scaleTo(Config_Home.scale_invterval, 1),
					cc.delayTime(Config_Home.scale_time_gap),
					cc.callFunc(function() {
						this.cur_index++;
						this.btnAniRepeat();
					}.bind(this))
			));
		}
    },
    addBackKeyListener:function(){
    	var self = this;
    	cc.eventManager.addListener({
    		event: cc.EventListener.KEYBOARD,
    		onKeyReleased: function(keyCode, event) {
    			if (keyCode == cc.KEY.back) {
    				if (self.layer_quit) {
                        self.layer_quit.removeFromParent(true);
                        self.layer_quit = null;
                    } else {
                        var ad_item = getQuitAd();

                        self.layer_quit = new QuitAdViewLayer(function(action) {
                            switch (action) {
                                case "quit":
                                {
                                    stopAllAudios();
                                    cc.director.end();
                                    break;
                                }
                                case "continue":
                                {
                                    self.layer_quit.removeFromParent(true);
                                    self.layer_quit = null;
                                    break;
                                }
                                default:
                                    break;
                            }
                        }, ad_item);

                        self.addChild(self.layer_quit, 550);
                    }
    			}
    	}}, this);
    },
    btnTouchEvent:function(sender, type){
            switch (type) {
                    case ccui.Widget.TOUCH_BEGAN:
                        break;

                    case ccui.Widget.TOUCH_MOVED:
                        break;

                    case ccui.Widget.TOUCH_ENDED:
                        showPrivacy();
                        break;

                    case ccui.Widget.TOUCH_CANCELED:
                        break;

                    default:
                        break;
                }
        },

    feedTouchEvent:function(sender, type){
                switch (type) {
                    case ccui.Widget.TOUCH_BEGAN:
                        break;

                    case ccui.Widget.TOUCH_MOVED:
                        break;

                    case ccui.Widget.TOUCH_ENDED:
                        showFeed();
                        break;

                    case ccui.Widget.TOUCH_CANCELED:
                        break;

                    default:
                        break;
                }
            },
    onEnter:function(){
        this._super();
        cc.audioEngine.playMusic("res/sound/background.mp3", true);
    },
    onExitTransitionDidStart:function(){
        this._super();
        cc.audioEngine.stopMusic();
    },
    getAdList:function (showAd) {
            getAdConfig("http://www.qinqinxiong.com/project/qqxmgr/admgr.php?pkg=" + getPackage() + "&channel=" + getChannel() + "&ver=" + verCode(),
                function(){
                    cc.log("request finish!!!");
                    var ad_value = cc.sys.localStorage.getItem(KEY_AD_LIST);
                    console.log(ad_value);
                    if (ad_value){
                        var parse_result = JSON.parse(ad_value);
                        AD_ENABLE = parse_result.enable;
                        var ad_home = parse_result.homead;
                        var ad_in = parse_result.inad;
                        var ad_quit = parse_result.quitad;

                        if (null != ad_home){
                            var ad_home_list = new Array(ad_home.length);
                            parseAdList(ad_home_list, ad_home);
                            ARRY_AD_HOME = filterAdInstall(ad_home_list, 4);
                        }

                        if (null != ad_in){
                            var ad_in_list = new Array(ad_in.length);
                            parseAdList(ad_in_list, ad_in);
                            ARRY_AD_IN = filterAdInstall(ad_in_list, 4);
                        }

                        if (null != ad_quit){
                            var ad_quit_list = new Array(ad_quit.length);
                            parseAdList(ad_quit_list, ad_quit);
                            ARRY_AD_QUIT = filterAdInstall(ad_quit_list, 4);
                        }

                        showAd();
                    }
                });

        }
});

var HomeScene = cc.Scene.extend({
    ctor:function () {
        this._super();
        var layer = new HomeLayer();
        this.addChild(layer);
    }
});

