
var SelectLayer = cc.Layer.extend({
	arry_cate:null,
	cur_index : null,
	arry_listener:null,
    ctor:function () {
        //////////////////////////////
        // 1. super init first
        this._super();
        this.arry_cate = new Array();
        this.cur_index = 0;
        this.createLayer();
        this.createSpriteListener();
        this.showEntryAni();
        this.addBackKeyListener();
        return true;
    },
    createLayer:function(){
    	cc.log();
    	var background = new cc.Sprite(resPaht("select", null, "background"));
    	background.setAnchorPoint(cc.p(0, 0));
    	background.scaleX = winWidth() / 1136;
    	this.addChild(background, 0);
    	
    	for(var n_index = 0; n_index < 5; ++n_index){
    		var item = new SelectItem(Config_Select.arry_name[n_index], Config_Select.arry_name_cn[n_index]);
    		item.setPosition(Config_Select.arry_pos[n_index]);
    		this.arry_cate[n_index] = item;
    		this.addChild(item, 5 + n_index);
    	}
    	
    	var arry_menu_item = [];
    	var backItem = new cc.MenuItemImage(
    			resPaht("home", null, "return"),
    			resPaht("home", null, "return"),
    			function () {
    				this.cleanScene();
    				cc.director.popScene();
    			}, this);
    	backItem.attr({
    		x: Config_Global.pos_ret.x,
    		y: Config_Global.pos_ret.y,
    		anchorX: 0.5,
    		anchorY: 0.5
    	});
    	arry_menu_item[0] = backItem;
    	
    	var menu = new cc.Menu(arry_menu_item);
    	menu.x = 0;
    	menu.y = 0;
    	this.addChild(menu, 100);
    },
    createSpriteListener:function(){
    	this.arry_listener = [null, null, null, null, null];
    	
    	var self = this;
    	var sprite_listener = cc.EventListener.create({
    		event: cc.EventListener.TOUCH_ONE_BY_ONE,
    		swallowTouches: true,
    		onTouchBegan: function (touch, event) {
    			self.sprite_select = null;
    			var target = event.getCurrentTarget();
    			var locationInNode = target.convertToNodeSpace(touch.getLocation());

    			var s = target.getContentSize();
    			var rect = cc.rect(0, 0, s.width, s.height);

    			if (cc.rectContainsPoint(rect, locationInNode)) {
    				self.sprite_select = target;
    				
    				return true;
    			}else {
    				self.sprite_select = null;
    			}
    			return false;
    		},
    		onTouchMoved: function (touch, event) {
    			
    		},
    		onTouchEnded: function (touch, event) {
    			self.checkSelect();
    		}
    	});

    	this.arry_listener[0] = sprite_listener.clone();
    	this.arry_listener[0].retain();
    	this.arry_listener[1] = sprite_listener.clone();
    	this.arry_listener[1].retain();
    	this.arry_listener[2] = sprite_listener.clone();
    	this.arry_listener[2].retain();
    	this.arry_listener[3] = sprite_listener.clone();
    	this.arry_listener[3].retain();
    	this.arry_listener[4] = sprite_listener.clone();
        this.arry_listener[4].retain();
    	
    	cc.eventManager.addListener(this.arry_listener[0], this.arry_cate[0]);
    	cc.eventManager.addListener(this.arry_listener[1], this.arry_cate[1]);
    	cc.eventManager.addListener(this.arry_listener[2], this.arry_cate[2]);
    	cc.eventManager.addListener(this.arry_listener[3], this.arry_cate[3]);
    	cc.eventManager.addListener(this.arry_listener[4], this.arry_cate[4]);
    },
    checkSelect:function(){
    	var n_group = -1;
    	if (this.sprite_select == this.arry_cate[0]) {
			n_group = 0;
    	}else if (this.sprite_select == this.arry_cate[1]) {
    		n_group = 1;
    	}else if (this.sprite_select == this.arry_cate[2]) {
    		n_group = 2;
    	}else if (this.sprite_select == this.arry_cate[3]) {
    		n_group = 3;
    	}else if (this.sprite_select == this.arry_cate[4]) {
            n_group = 4;
       	}
    	
    	if (-1 != n_group) {
    		customPlayEffect(audioTipsPath(), false);
    		cc.director.pushScene(new cc.TransitionFade(0.3, new LearnScene(n_group)));
		}
    },
    showEntryAni:function(){
    	this.arry_cate[this.cur_index].runAction(cc.sequence(
    		cc.scaleTo(0.2, 0.9),
    		cc.scaleTo(0.3, 1.1),
    		cc.scaleTo(0.2, 0.9),
    		cc.delayTime(1),
    		cc.callFunc(function(){
    			this.cur_index = (this.cur_index + 1) % 5;
    			this.showEntryAni();
    		}.bind(this))
    	));
    },
    cleanScene:function(){
    	cc.log("clean scene click!");
    	for (var n_index = 0; n_index < this.arry_listener.length; n_index++) {
    		cc.eventManager.removeListener(this.arry_listener[n_index]);
    		releaseObj(this.arry_listener[n_index]);
    	}
    },
    addBackKeyListener:function(){
    	var self = this;
    	cc.eventManager.addListener({
    		event: cc.EventListener.KEYBOARD,
    		onKeyReleased: function(keyCode, event) {
    			if (keyCode == cc.KEY.back) {
    				cc.log("end game");
    				cc.audioEngine.stopAllEffects();
    				self.cleanScene();
    				cc.director.popScene();
    			}
    		}}, this);
    }
});

var SelectScene = cc.Scene.extend({
    ctor:function () {
        this._super();
        var layer = new SelectLayer();
        this.addChild(layer);
    }
});

